
$onEolCom
* ================input scalars=========================
* scalars used in 'sets' setting
$setlocal   Nt  24      !! number of time steps in one scenario
$setlocal   Ni  14      !! number of nodes
$setlocal   Ns  4       !! number of scenarios


Scalars
* Numbers
    Dp          'number of days in one year'                 /365/
    
* Unit costs
    c_OM_DG     'O&M cost of diesel, $/h'                    /0.05/    

* others
    Base     'Base of power, MVA'                            /100/ ;

Sets
    t        'time step'                              /1*%Nt%/
    i        'node'                                   /1*%Ni%/
    s        'scenario'                               /1*%Ns%/
    f        'equipment in the system'                /'wind', 'PV', 'TCF', 'DG'/  !! wind farm, PV plant, tidal current farm, diesel generator
Alias (i,j);

Parameters
* probability of scenario   
    omega(s)      'probability of scenarios'
        /'1'    0.25
         '2'    0.25
         '3'    0.25
         '4'    0.25       / 
         

    Load_max(i)    'Peak load, MW' 
        /'2'    0.112
         '4'    0.478
         '5'    0.217
         '9'    0.295
         '10'   0.390
         '11'   0.35
         '12'   0.461
         '13'   0.23
         '14'   0.25        /;

        
Table    Cap_ed(f,i)     'Capacity of installed equipment, MW, MWh'
         '1'    '2'    '3'    '4'    '5'    '6'    '7'    '8'    '9'    '10'    '11'    '12'    '13'    '14'
'wind'                                                                                          0
'PV'                                        0
'TCF'                   0                                                          
'DG'     3                                                3                                                     ;


Table   Cap_cab_max(i,j)    'upper bounds of cable capacity, MW' 
         '1'    '2'    '3'    '4'    '5'    '6'    '7'    '8'    '9'    '10'    '11'    '12'    '13'    '14'
'1'               4                    4
'2'        4             4      4      4
'3'               4             4
'4'               4      4             4             4             4
'5'        4      4             4             4
'6'                                    4                                           4       4       4
'7'                             4                           4      4
'8'                                                  4
'9'                             4                    4                     4                               4
'10'                                                               4               4
'11'                                          4                            4
'12'                                          4                                                    4
'13'                                          4                                            4               4
'14'                                                               4                               4                    ;

Table x_ij(i,j)         'reactance of cable, p.u.'
        '1'           '2'         '3'         '4'          '5'         '6'         '7'         '8'         '9'         '10'        '11'         '12'        '13'        '14'
'1'                   0.05917                              0.22304                
'2'     0.05917                   0.19797     0.17632      0.17388                
'3'                   0.19797                 0.17103                   
'4'                   0.17632     0.17103                  0.04211                 0.20912                 0.55618        
'5'     0.22304       0.17388                 0.04211                  0.25202              
'6'                                                        0.25202                                                                 0.19890      0.25581     0.13027    
'7'                                           0.20912                                          0.17615     0.11001        
'8'                                                                                0.17615            
'9'                                           0.55618                              0.11001                             0.08450                                          0.27038    
'10'                                                                                                       0.08450                 0.19207    
'11'                                                                   0.19890                                         0.19207      
'12'                                                                   0.25581                                                                              0.19988    
'13'                                                                   0.13027                                                                  0.19988                 0.34802   
'14'                                                                                                       0.27038                                          0.34802                 ;

Table b_ij(i,j)         'susceptance of cable, p.u.'
        '1'           '2'         '3'         '4'          '5'         '6'         '7'         '8'         '9'         '10'        '11'         '12'        '13'        '14'
'1'                   [1/0.05917]                          [1/0.22304]            
'2'     [1/0.05917]               [1/0.19797] [1/0.17632]  [1/0.17388]            
'3'                   [1/0.19797]             [1/0.17103]               
'4'                   [1/0.17632] [1/0.17103]              [1/0.04211]             [1/0.20912]             [1/0.55618]    
'5'     [1/0.22304]   [1/0.17388]             [1/0.04211]              [1/0.25202]           
'6'                                                        [1/0.25202]                                                             [1/0.19890]  [1/0.25581] [1/0.13027]
'7'                                           [1/0.20912]                                      [1/0.17615] [1/0.11001]    
'8'                                                                                [1/0.17615]        
'9'                                           [1/0.55618]                          [1/0.11001]                         [1/0.08450]                                      [1/0.27038]
'10'                                                                                                       [1/0.08450]             [1/0.19207]
'11'                                                                   [1/0.19890]                                     [1/0.19207]  
'12'                                                                   [1/0.25581]                                                                          [1/0.19988]
'13'                                                                   [1/0.13027]                                                              [1/0.19988]             [1/0.34802]
'14'                                                                                                       [1/0.27038]                                      [1/0.34802]             ;

* self-susceptance
b_ij('1','1') = -b_ij('1','2')-b_ij('1','5');
b_ij('2','2') = -b_ij('2','1')-b_ij('2','3')-b_ij('2','4')-b_ij('2','5');
b_ij('3','3') = -b_ij('3','2')-b_ij('3','4');
b_ij('4','4') = -b_ij('4','2')-b_ij('4','3')-b_ij('4','5')-b_ij('4','7')-b_ij('4','9');
b_ij('5','5') = -b_ij('5','1')-b_ij('5','2')-b_ij('5','4')-b_ij('5','6');
b_ij('6','6') = -b_ij('6','5')-b_ij('6','11')-b_ij('6','12')-b_ij('6','13');
b_ij('7','7') = -b_ij('7','4')-b_ij('7','8')-b_ij('7','9');
b_ij('8','8') = -b_ij('8','7');
b_ij('9','9') = -b_ij('9','4')-b_ij('9','7')-b_ij('9','10')-b_ij('9','14');
b_ij('10','10') = -b_ij('10','9')-b_ij('10','11');
b_ij('11','11') = -b_ij('11','6')-b_ij('11','10');
b_ij('12','12') = -b_ij('12','6')-b_ij('12','13');
b_ij('13','13') = -b_ij('13','6')-b_ij('13','12')-b_ij('13','14');
b_ij('14','14') = -b_ij('14','9')-b_ij('14','13');

* =========import power data from Excel=========  Ҫ��csv����
* normalized wind scenarios
Parameter P_wind_norm(s,t);
$call 'del wind.gdx'
$call gdxxrw I=wind.xlsx O=wind.gdx par=P_wind_norm rdim=1 cdim=1 rng=sheet1!A1:Y5
$gdxin wind.gdx
$loaddc P_wind_norm
$gdxin

* normalized PV scenarios
Parameter P_PV_norm(s,t);
$call 'del PV.gdx'
$call gdxxrw I=PV.xlsx O=PV.gdx par=P_PV_norm rdim=1 cdim=1 rng=sheet1!A1:Y5
$gdxin PV.gdx
$loaddc P_PV_norm
$gdxin

* normalized TCF scenarios
Parameter P_TCF_norm(s,t);
$call 'del TCF.gdx'
$call gdxxrw I=TCF.xlsx O=TCF.gdx par=P_TCF_norm rdim=1 cdim=1 rng=sheet1!A1:Y5
$gdxin TCF.gdx
$loaddc P_TCF_norm
$gdxin

* load scenarios
Parameter P_load_norm(s,t);
$call 'del load.gdx'
$call gdxxrw I=load.xlsx O=load.gdx par=P_load_norm rdim=1 cdim=1 rng=sheet1!A1:Y5
$gdxin load.gdx
$loaddc P_load_norm
$gdxin

Parameter   P_wind(i,s,t)    'actual power of wind farm, MW';
            P_wind(i,s,t) = P_wind_norm(s,t)*Cap_ed('wind',i)/Base; 

Parameter   P_PV(i,s,t)    'actual power of PV plant, MW';
            P_PV(i,s,t) = P_PV_norm(s,t)*Cap_ed('PV',i)/Base;
            
Parameter   P_TCF(i,s,t)    'actual power of TCF, MW';
            P_TCF(i,s,t) = P_TCF_norm(s,t)*Cap_ed('TCF',i)/Base;
            
Parameter   P_load(i,s,t)    'actual load, MW';
            P_load(i,s,t) = P_load_norm(s,t)*Load_max(i)/Base;
              

* ===============Optimization variables=================    
Variable
* Objective function
    C_tot       'Total annual cost of MG, $' 
    
* Power flow
    P_ij(i,j,s,t)    'Power from i to j'
    theta_i(i,s,t)   'Phase angle at node i'
    
    
Positive variables    
* DG
    P_DG(i,s,t)     'DG Power output, MW'
    

* ==============Objective functions==========================
Equations
* Declaration of objective function
Obj_fun         'Objective function';

* Definition of objective function
Obj_fun   ..    C_tot =e= sum((i,s,t), omega(s)*c_OM_DG*P_DG(i,s,t)*Base)*Dp;


* ========================Constraints========================
* Power flow
Equations
* Declaration
Node_balance(i,s,t)        'Power balance at each node except for the node with HSS'
MG_balance(s,t)            'Power balance in MG'
Angle_Power1(i,j,s,t)      'PX=theta,i<>j'
Angle_Power2(i,j,s,t)      'PX=theta,i=j'
Line_MaxPower1(i,j,s,t)    'Upper bound of line power, j to i'
Line_MaxPower2(j,i,s,t)    'Upper bound of line power, i to j'
Angle_Min(i,s,t)           'Lower bound of phase angle'
Angle_Max(i,s,t)           'Upper bound of phase angle'
DG_MaxPower(i,s,t)         'DG power'   ;


Node_balance(i,s,t)$(ord(i)<>1)       ..     (P_wind(i,s,t)+P_PV(i,s,t)+P_TCF(i,s,t)+P_DG(i,s,t))-P_load(i,s,t)
                                                                =e= -sum(j$(ord(j)<>1), b_ij(i,j)*theta_i(j,s,t)) ;  
                                                 
MG_balance(s,t)                       ..     sum(i, P_wind(i,s,t)+P_PV(i,s,t)+P_TCF(i,s,t)+P_DG(i,s,t)-P_load(i,s,t)) =e= 0;

Angle_Power1(i,j,s,t)                 ..     P_ij(i,j,s,t)*x_ij(i,j) =e= theta_i(i,s,t)-theta_i(j,s,t) ;  !! $(ord(i)<>ord(j))
Angle_Power2(i,j,s,t)$(ord(i)=ord(j)) ..     P_ij(i,j,s,t) =e= 0 ;
                                                
Line_MaxPower1(i,j,s,t)               ..     P_ij(i,j,s,t) =g= -Cap_cab_max(i,j)/Base ;
Line_MaxPower2(i,j,s,t)               ..     P_ij(i,j,s,t) =l= Cap_cab_max(i,j)/Base ;

Angle_Min(i,s,t)                      ..     theta_i(i,s,t) =g= -pi/4;
Angle_Max(i,s,t)                      ..     theta_i(i,s,t) =l= pi/4;

DG_MaxPower(i,s,t)                    ..     P_DG(i,s,t) =l= Cap_ed('DG',i)/Base;

                                       
* Fix the phase angle of slack bus
theta_i.fx('1',s,t) = 0;

* =====================solve the model==================
model m /Obj_fun,
         Node_balance, MG_balance, Angle_Power1, 
         
         /;   !! DG_MaxPower, Line_MaxPower1,Line_MaxPower2,  Angle_Min, Angle_Max,  Angle_Power2, 


Option LP = cplex;
option reslim = 1000
option limrow = 500;

solve m minimizing C_tot using LP;
